<?php
function ShowPMForm($id)
{
  if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash']) and $GLOBALS['islogged']){ //если куки авторизации есть и есть логин
    if (isset($_SESSION['PMForm'])){ // если форма уже была заполнена но с ошибками, все данные берём из сессии
      $error = $_SESSION['PMForm']['error'];
      $topic = $_SESSION['PMForm']['topic'];
      unset($_SESSION['PMForm']);
    }else{ //в противном случае все поля пустые
      $error = '';
      $topic = '';
    }
  }else{ //если куки нету
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Авторизуйтесь, чтобы отправлять личные сообщения.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
    exit();
  }
 
if ($_COOKIE['iduser'] == $id) {
  $_SESSION['msg'] = 'Форум не предполагает общения с самим собой через личные сообщения.';
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
  else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
  exit();
}

$id = (int)substr("$id", 0, 6); //на всякий случай ограничиваем длину

$stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT name FROM users WHERE iduser=? LIMIT 1');
mysqli_stmt_bind_param($stmt, 'i', $id);
mysqli_stmt_execute($stmt);
mysqli_stmt_bind_result($stmt, $name);
mysqli_stmt_fetch($stmt);
mysqli_stmt_close($stmt);

if (!isset($name)){
  $_SESSION['msg'] = 'Такого участника нет.';
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
  else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
  exit();
}

// проверка на наличие себя в чёрном списке получателя
$stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_item FROM wblist WHERE id_from=? AND id_to=? AND listid=-1 LIMIT 1');
mysqli_stmt_bind_param($stmt, 'ii', $id, intval($_COOKIE['iduser']));
mysqli_stmt_execute($stmt);
mysqli_stmt_store_result($stmt);
$num = mysqli_stmt_num_rows($stmt);
mysqli_stmt_close($stmt);
if($num > 0){
  $_SESSION['msg'] = 'Участник запретил Вам отправлять сообщения.';
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
  else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
  exit();
}

$html = file_get_contents('./templates/PMForm.html');
$html = str_replace('{name_to}', $name, $html);
$html = str_replace('{id_to}', $id, $html);
$html = str_replace('{error}', $error, $html);
$html = str_replace('{topic}', $topic, $html);
$html = str_replace('{message}', '', $html);

return $html;
}
?>