<?php
require 'CountMail.php';
require 'const.php';
session_start();

$email = substr($_POST['email'], 0, 129);
$email = trim($email);
$email = mb_strtolower($email); //приводим адрес почты к нижнему регистру
if (!empty($email))  //если адрес почты не пустой  
{
$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname); 
  $stmt = mysqli_prepare($DB, "SELECT name, user_hash FROM users WHERE email=? LIMIT 1");
  mysqli_stmt_bind_param($stmt, "s", $email);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $name, $hash); //если такой юзер был зарегистрирован, то берём его хэш для смены пароля
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (isset($_COOKIE['hash'])){ // если юзер залогинен
    if ($_COOKIE['hash'] !== $hash) { //если куки не совпадают с хэшем юзера, email которого был указан, то пресекаем такую странную активность
      mysqli_close($DB); 
      $_SESSION['msg'] = 'Вы указали адрес, не ассоциированный с Вашей учётной записью.';
      if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
      else header('Location: http://'.$HostName.'/?ai=200');
      exit();
    }
  }

  if (!empty($hash)){ //если такой пользователь есть в базе
    $np = CountMail($email);//проверяем сколько всего отправлено писем на данный ящик за предыдущий час
    if ($np<2){ //ограничение здесь на 2 письма в час
      $n = CountMail(); //проверяем сколько всего отправлено писем за предыдущий час
      if ($n<150){ // реальный лимит 200, но берём здесь с запасом на всякий случай
      //готовим письмо для смены пароля 
        $subject = 'Смена пароля к учётной записи на форуме AGI.place';   
        $headers = "From: AGI.place <mail@agi.place>\n";
        $headers .= "Content-type: text/html; charset=\"utf-8\"\n";
        $headers .= "Return-path: <mail@agi.place>\n";
        $message = 'Уважаемый(ая) <b>'.$name.'</b><br><br>'."\n";
        $message .= 'Для смены пароля к своей учётной записи на форуме AGI.place<br>'."\n";
        $message .= 'перейдите по ссылке:<br>'."\n";
        $link = 'http://'.$HostName.'/?ai=101&code='.$hash;
        $message .= '<a href="'.$link.'">'.$link.'</a><br><br>'."\n";
        $message .= 'Если Вы не запрашивали смену пароля к своей учётной записи,<br>'."\n";
        $message .= 'то проигнорируйте данное письмо.<br><br>'."\n";
        $message .= 'С Уважением<br>'."\n";
        $message .= 'администратор форума AGI.place'."\n";
  
        if (mail($email, $subject, $message, $headers)){  
          $sendtime = date("Y-m-d H:i:s"); //добавляем в базу для подсчёта отправленных писем
          $stmt = mysqli_prepare($GLOBALS['DB'], "INSERT INTO mailcounter SET email=?, sendtime=?");
          mysqli_stmt_bind_param($stmt, "ss", $email, $sendtime);
          mysqli_stmt_execute($stmt);
          mysqli_stmt_close($stmt);
        }
      }
    }
}  
mysqli_close($DB); 
}
//независимо от результата показываем одно и то же информационное сообщение, чтобы потенциальный злоумышленник не получил даже косвенной информации
$_SESSION['msg'] = 'Предпринята попытка отправки письма на указанный адрес.<br>Для смены пароля следуйте инструкциям, указанным в письме.';
} 
if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
else header('Location: http://'.$HostName.'/?ai=200');
?>