<?php
function ActivateUserEmail($id, $code){
$id = substr($id, 0, 32); 
$code = substr($code, 0, 6);

$stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT emailcode, smscode FROM users WHERE user_hash=? LIMIT 1');
mysqli_stmt_bind_param($stmt, 's', $id);
mysqli_stmt_execute($stmt);
mysqli_stmt_bind_result($stmt, $codeDB, $smscode);
mysqli_stmt_fetch($stmt);
mysqli_stmt_close($stmt);

$html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
  <tr><td><div align="center">{msg}</div></td></tr><tr><td height="10px"></td></tr></table>';

switch ($codeDB){
  case '0':
    $html = str_replace('{msg}', 'Вы можете осуществить активацию через свою учётную запись.', $html);
    break;
  case '1':
    $html = str_replace('{msg}', 'Вы уже активировали свою учётную запись по электронной почте.', $html);
    break;
  default:
    if ("$code" !== "$codeDB"){
      $stmt = mysqli_prepare($GLOBALS['DB'], "UPDATE users SET emailcode='0' WHERE user_hash=?");// '0' - значит попытка активации была, но она неудачная
      mysqli_stmt_bind_param($stmt, 's', $id);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);
      $html = str_replace('{msg}', 'Данные введены некорректно.<br>Повторную активацию Вы можете осуществить через свою учётную запись.', $html);
    }else{

      if ($smscode == '1') $status = 'create';
      else $status = 'write';
      
      $stmt = mysqli_prepare($GLOBALS['DB'], "UPDATE users SET emailcode='1', status=? WHERE user_hash=?");
      mysqli_stmt_bind_param($stmt, 'ss', $status, $id);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);
      $html = str_replace('{msg}', 'Учётная запись успешно активирована по электронной почте.<br>Теперь у Вас есть право создавать сообщения в топиках.', $html);
    }
}
return $html;
}
?>