<?php
function PageIteratorCreate($MaxCount, $TotalPages, $FocusPage, $UrlTemplate){//$MaxCount - длина итератора (страниц), $TotalPages - сколько страниц нужно отобразить
$html = '';
if ($TotalPages <= $MaxCount){ //в этом случае рисуем всё подряд и фокусную кнопку
  for ($i = 1; $i <= $TotalPages; $i++){
    if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
    }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
  }
}else{ //в этом случае обязательно вставляем разрыв (...) или два разрыва в зависимости от местоположения фокуса
  if ($FocusPage<($MaxCount-2)){
    for ($i = 1; $i <= ($MaxCount-2); $i++){
      if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
      }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
    }
    $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки
    $html .= '<td><a href="'.$UrlTemplate."$TotalPages".'"><div class="PageInactive">'."$TotalPages".'</div></a></td>'; //ставим последнюю страницу
  }elseif ($FocusPage>($TotalPages-($MaxCount-3))){
    $html = '<td><a href="'.$UrlTemplate.'1"><div class="PageInactive">1</div></a></td>';
    $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки  
    for ($i = ($TotalPages-($MaxCount-3)); $i <= $TotalPages; $i++){
      if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
      }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
    }
  }else{
    $center = round($MaxCount / 2, 0, PHP_ROUND_HALF_UP); //вычисляем номер центральной кнопки на итераторе
    $leftside = $FocusPage - $center + 1; // получаем номер первой левой кнопки так, как если бы мы рисовали от центра
    // если leftside равен 1, значит можно рисовать с начала при этом фокусная кнопка окажется точно в центре и справа поставить три точки.
    // если leftside < 1 значит можно рисовать с начала при этом фокусная кнопка окажется не в центре и справа поставить три точки.
    // если leftside > 1 значит слева надо проверять rightside.
    $rightside = $FocusPage + ($MaxCount - $center);// получаем номер последней правой кнопки так, как если бы мы рисовали от центра
    // если rightside равен TotalPages значит можно ставить слева три точки рисовать с начала и при этом фокусная кнопка окажется точно в центре.
    // если rightside > TotalPages значит можно ставить слева три точки рисовать с начала и при этом фокусная кнопка окажется не в центре.
    // если rightside < TotalPages значит слева и справа надо ставить три точки и рисовать от центра.
    if ($leftside <= 1){
      for ($i = 1; $i <= ($MaxCount-2); $i++){
        if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
        }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
      }
      $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки
      $html .= '<td><a href="'.$UrlTemplate."$TotalPages".'"><div class="PageInactive">'."$TotalPages".'</div></a></td>'; //ставим последнюю страницу
    }elseif ($rightside >= $TotalPages){
      $html = '<td><a href="'.$UrlTemplate.'1"><div class="PageInactive">1</div></a></td>';
      $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки  
      for ($i = ($TotalPages-($MaxCount-3)); $i <= $TotalPages; $i++){
        if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
        }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
      }
    }else{
      $html = '<td><a href="'.$UrlTemplate.'1"><div class="PageInactive">1</div></a></td>';
      $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки  
      for ($i = ($FocusPage - $center + 3); $i <= $FocusPage + ($MaxCount - $center) - 2; $i++){
        if ($i == $FocusPage){$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageFocused">'."$i".'</div></a></td>';
        }else{$html .= '<td><a href="'.$UrlTemplate."$i".'"><div class="PageInactive">'."$i".'</div></a></td>';}
      }
      $html .= '<td><a><div class="PageInactive"><strong>…</strong></div></a></td>'; //три точки
      $html .= '<td><a href="'.$UrlTemplate."$TotalPages".'"><div class="PageInactive">'."$TotalPages".'</div></a></td>'; //ставим последнюю страницу
    }
  }
}
return $html;
}
?>